import torch

class SyntheticRegressionData:
    """ Class to generate synthetic regression data 
        Adapted from Chapter 3 of https://d2l.ai/index.html
    """
    def __init__(self, w, b, noise=0.01, m=1000,
                 batch_size=32):
        super().__init__()
        self.w = w
        self.b = b
        self.X = torch.randn(m, len(w))
        noise = torch.randn(m, 1) * noise
        self.y = torch.matmul(self.X, w.reshape((-1, 1))) + b + noise

class LinearRegression(torch.nn.Module): 
    """ Class for linear regression
    """
    #TODO: Complete this class
    def __init__(self, num_inputs, sigma=0.01):
        super().__init__()

    def loss(self, y_hat, y):
        # This is complete
        return ((y_hat - y) ** 2 / 2 ).mean() 


def train(model, data): 
    # This is complete, DO NOT MODIFY IT
    X = data.X
    y = data.y

    optimizer = torch.optim.SGD(model.parameters(), lr=0.3, momentum=0.9)
    for t in range(30):
        y_pred = model(X)
        loss = model.loss(y_pred, y)
        if t % 10 == 0:
            print(t, loss.item())
        optimizer.zero_grad()
        loss.backward()
        optimizer.step()

def batched_train(model, data, batch_size=100):
    #TODO: Complete this function
    pass

if __name__ == '__main__':

    # Create data
    data = SyntheticRegressionData(w=torch.tensor([2, -3.4, 6.1]), b=4.2)

    # Your code goes below
